<template>
  <!-- 新增编辑 -->
  <common-modal
    :width="700"
    :maskClosable="false"
    :visible="props.visible"
    :confirm-loading="loading"
    :forceRender="true"
    wrapClassName="project-modal"
    :title="isUpdate ? '编辑字典类型' : '新建字典类型'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
    @close="updateVisible(false)"
  >
    <DictTypeForm
      v-model:form="form"
      ref="typeFormRef"
      :isUpdate="isUpdate"
      :type="props.type"
      :linkWorkItemData="props.linkWorkItemData"
    ></DictTypeForm>

    <template #footer>
      <a-button class="border-radius grey" @click="updateVisible(false)" type="link">取消</a-button>
      <a-button class="border-radius" type="primary" @click="save">{{ props.type == 'app' ? '确定' : '保存并配置' }}</a-button>
    </template>
  </common-modal>
</template>

<script setup name="UserDictTypeAddEdit">
import { ref, onMounted } from 'vue';
import DictTypeForm from './user-dict-type-form.vue';
import { message } from 'ant-design-vue';
import { MetaUserDictApi } from '../../../api/MetaUserDictApi';

const props = defineProps({
  visible: Boolean,
  data: Object,
  businessId: String,
  linkWorkItemData: Object,
  type: {
    type: String,
    default: 'app'
  }
});

const emits = defineEmits(['update:visible', 'done']);
// 弹框加载
const loading = ref(false);
// 是否是编辑状态
const isUpdate = ref(false);
// 表单数据
const form = ref({
  dictTypeSort: 100
});
// ref
const typeFormRef = ref(null);

onMounted(async () => {
  if (props.data) {
    isUpdate.value = true;
    getDetail();
  } else {
    if (props.businessId) form.value.businessId = props.businessId;
    isUpdate.value = false;
    if (props.type == 'task') {
      form.value.linkWorkItemId = props.linkWorkItemData?.id;
      form.value.linkWorkItemIdWrapper = props.linkWorkItemData?.title;
    }
  }
});

// 获取详情
const getDetail = () => {
  MetaUserDictApi.dictTypeDetail({ metaUserDictId: props.data.dictTypeId }).then(res => {
    form.value = Object.assign({}, res);
  });
};

// 更改弹框状态
const updateVisible = value => {
  emits('update:visible', value);
};

// 点击保存
const save = async () => {
  typeFormRef.value.$refs.formRef.validate().then(async valid => {
    if (valid) {
      // 修改加载框为正在加载
      loading.value = true;

      let result = null;

      // 执行编辑或修改
      if (isUpdate.value) {
        result = MetaUserDictApi.dictTypeEdit(form.value);
      } else {
        result = MetaUserDictApi.dictTypeAdd(form.value);
      }
      result
        .then(async result => {
          // 移除加载框
          loading.value = false;

          // 提示添加成功
          message.success(result.message);
          // 关闭弹框，通过控制visible的值，传递给父组件
          updateVisible(false);

          // 触发父组件done事件
          emits('done', result.data);
        })
        .catch(() => {
          loading.value = false;
        });
    }
  });
};
</script>

<style></style>
